<template>
  <b-row>
    <div class="col-sm-2" />
    <div class="col-sm-8">
      <b-form @submit.stop.prevent="">
        <!-- Personal Information -->
        <CoscineHeadline
          :headline="$t('page.userprofile.form.personalInformation.header')"
        />

        <!-- Title -->
        <CoscineFormGroup
          label-for="title"
          :label="
            $t('page.userprofile.form.personalInformation.labels.titleLabel')
          "
          :is-loading="isLoading"
          type="input"
        >
          <multiselect
            id="title"
            ref="title"
            v-model="v$.userForUpdate.title.$model"
            :options="titles"
            :multiple="false"
            label="displayName"
            track-by="id"
            :show-labels="false"
            :placeholder="
              $t(
                'page.userprofile.form.personalInformation.multiselect.placeholderTitle',
              )
            "
            :select-label="
              $t(
                'page.userprofile.form.personalInformation.multiselect.selectEnter',
              )
            "
          >
            <template #noResult>
              {{
                $t(
                  "page.userprofile.form.personalInformation.multiselect.noResults",
                )
              }}
            </template>
            <template #noOptions>
              {{
                $t(
                  "page.userprofile.form.personalInformation.multiselect.noOptions",
                )
              }}
            </template>
          </multiselect>
        </CoscineFormGroup>

        <!-- First Name -->
        <CoscineFormGroup
          :mandatory="true"
          label-for="givenName"
          :label="
            $t(
              'page.userprofile.form.personalInformation.labels.firstNameLabel',
            )
          "
          :is-loading="isLoading"
          type="input"
        >
          <b-form-input
            id="givenName"
            v-model="v$.userForUpdate.givenName.$model"
            :state="
              v$.userForUpdate.givenName.$dirty
                ? !v$.userForUpdate.givenName.$invalid
                : null
            "
            :placeholder="
              $t('page.userprofile.form.personalInformation.givenName')
            "
            :maxlength="v$.userForUpdate.givenName.maxLength.$params.max"
          />
        </CoscineFormGroup>

        <!-- Last Name -->
        <CoscineFormGroup
          :mandatory="true"
          label-for="familyName"
          :label="
            $t('page.userprofile.form.personalInformation.labels.lastNameLabel')
          "
          :is-loading="isLoading"
          type="input"
        >
          <b-form-input
            id="familyName"
            v-model="v$.userForUpdate.familyName.$model"
            :state="
              v$.userForUpdate.familyName.$dirty
                ? !v$.userForUpdate.familyName.$invalid
                : null
            "
            :placeholder="
              $t('page.userprofile.form.personalInformation.familyName')
            "
            :maxlength="v$.userForUpdate.familyName.maxLength.$params.max"
          />
        </CoscineFormGroup>

        <!-- Email -->
        <CoscineFormGroup
          :mandatory="true"
          label-for="email"
          :label="
            $t('page.userprofile.form.personalInformation.labels.emailLabel')
          "
          :is-loading="isLoading"
          type="input"
        >
          <div class="w-100">
            <b-form-input
              id="email"
              v-model="v$.userForUpdate.email.$model"
              :state="
                v$.userForUpdate.email.$dirty || !userForUpdate.email
                  ? !v$.userForUpdate.email.$invalid
                  : null
              "
              :placeholder="
                $t('page.userprofile.form.personalInformation.email')
              "
              :maxlength="v$.userForUpdate.email.maxLength.$params.max"
            />
            <div id="emailHint">
              {{ emailHint }}
            </div>
          </div>
        </CoscineFormGroup>

        <!-- Organization -->
        <CoscineFormGroup
          :mandatory="true"
          label-for="organization"
          :label="
            $t(
              'page.userprofile.form.personalInformation.labels.organizationLabel',
            )
          "
          :is-loading="isLoading"
          type="input"
        >
          <!-- Organization - External User -->
          <multiselect
            v-if="!readOnlyOrganization"
            id="organization"
            ref="organization"
            v-model="v$.userForUpdate.organization.$model"
            :options="ror"
            :multiple="false"
            :loading="isLoadingOrganizations"
            :show-labels="false"
            :placeholder="
              $t(
                'page.userprofile.form.personalInformation.multiselect.placeholderText',
              )
            "
            @search-change="triggerFetchOptions"
          >
            <template #noResult="props">
              <span v-if="props.search.length < searchCharThreshold">
                {{
                  $t(
                    "page.userprofile.form.personalInformation.multiselect.searchNotEnoughCharacters",
                    { min: searchCharThreshold },
                  )
                }}
              </span>
              <span v-else>
                {{
                  $t(
                    "page.userprofile.form.personalInformation.multiselect.noResults",
                  )
                }}
              </span>
            </template>
            <template #noOptions>
              <span v-if="!isLoadingOrganizations">
                {{
                  $t(
                    "page.userprofile.form.personalInformation.multiselect.noOptionsOrganization",
                  )
                }}
              </span>
            </template>
          </multiselect>

          <!-- Organization - Internal User -->
          <multiselect
            v-else
            id="organization"
            ref="organization"
            v-model="organizations"
            :options="organizations"
            :multiple="true"
            :show-labels="false"
            :placeholder="
              $t('page.userprofile.form.personalInformation.organization')
            "
            :disabled="true"
          />
        </CoscineFormGroup>

        <!-- Discipline -->
        <CoscineFormGroup
          :mandatory="true"
          label-for="Discipline"
          :label="
            $t(
              'page.userprofile.form.personalInformation.labels.disciplineLabel',
            )
          "
          :is-loading="isLoading"
          type="input"
        >
          <multiselect
            id="Discipline"
            ref="Discipline"
            v-model="v$.userForUpdate.disciplines.$model"
            :options="disciplines"
            :multiple="true"
            :label="disciplineLabel"
            :track-by="disciplineLabel"
            :show-labels="false"
            :placeholder="
              $t(
                'page.userprofile.form.personalInformation.multiselect.placeholderDiscipline',
              )
            "
          >
            <template #singleLabel="props">
              {{ props.option[disciplineLabel] }}
            </template>
            <template #option="props">
              {{ props.option[disciplineLabel] }}
            </template>
          </multiselect>
        </CoscineFormGroup>

        <!-- Access Token -->
        <div class="h-divider" />
        <CoscineHeadline
          :headline="$t('page.userprofile.form.accessToken.header')"
        />
        <AccessToken />

        <!-- User Preferences -->
        <div class="h-divider" />
        <CoscineHeadline
          :headline="$t('page.userprofile.form.userPreferences.header')"
        />
        <!-- Language -->
        <CoscineFormGroup
          :mandatory="true"
          label-for="language"
          :label="
            $t('page.userprofile.form.userPreferences.labels.languageLabel')
          "
          :is-loading="isLoading"
          type="button"
        >
          <b-form-radio-group
            id="language"
            class="bv-no-focus-ring"
            :model-value="
              userForUpdate.language && userForUpdate.language.id
                ? userForUpdate.language.id
                : false
            "
            :state="
              v$.userForUpdate.language.$dirty
                ? userForUpdate.language && userForUpdate.language.id
                  ? null
                  : false
                : null
            "
            :options="languages"
            name="radios-stacked"
            text-field="displayName"
            value-field="id"
            stacked
            @update:modelValue="setLanguage"
          />
        </CoscineFormGroup>

        <!-- Connected Accounts -->
        <div class="h-divider" />
        <CoscineHeadline
          :headline="$t('page.userprofile.form.connectedAccounts.header')"
        />
        <!-- NFDI4Ing AAI -->
        <CoscineFormGroup
          :mandatory="true"
          :label="
            $t(
              'page.userprofile.form.connectedAccounts.labels.nfdi4IngAaiLabel',
            )
          "
          :is-loading="isLoading"
          type="button"
        >
          <b-button
            variant="secondary"
            name="nfdi4IngAaiConnect"
            :disabled="nfdi4IngAaiConnected"
            @click.prevent="clickNfdi4IngAaiConnect()"
          >
            <img
              class="d-inline me-1 position-relative"
              style="width: 2rem; top: -0.1rem"
              alt="NFDI sign in key"
              src="@/assets/svg/NFDI_key_icon.svg"
            />
            {{
              nfdi4IngAaiConnected
                ? $t("buttons.connected")
                : $t("buttons.connect")
            }}
          </b-button>
        </CoscineFormGroup>
        <!-- ORCID -->
        <CoscineFormGroup
          :mandatory="true"
          :label="
            $t('page.userprofile.form.connectedAccounts.labels.orcidLabel')
          "
          :is-loading="isLoading"
          type="button"
        >
          <b-button
            variant="secondary"
            name="orcidConnect"
            :disabled="orcidConnected"
            @click.prevent="clickOrcidConnect()"
          >
            <img
              class="d-inline me-1"
              style="width: 1.5rem"
              alt="ORCID logo"
              src="@/assets/svg/ORCIDiD_iconvector.svg"
            />
            {{
              orcidConnected ? $t("buttons.connected") : $t("buttons.connect")
            }}
          </b-button>
        </CoscineFormGroup>
        <!-- SSO -->
        <CoscineFormGroup
          :label="
            $t('page.userprofile.form.connectedAccounts.labels.shibbolethLabel')
          "
          :is-loading="isLoading"
          type="button"
        >
          <b-button
            v-if="shibbolethConnected"
            variant="secondary"
            name="shibbolethConnect"
            :disabled="true"
            @click.prevent="clickSsoConnect()"
          >
            {{ $t("buttons.connected") }}
          </b-button>
          <span v-else class="text-secondary">
            {{
              $t("page.userprofile.form.connectedAccounts.shibbolethMergeOff")
            }}
          </span>
        </CoscineFormGroup>

        <!-- Save Button -->
        <CoscineFormGroup>
          <b-button
            id="saveBtn"
            ref="saveBtn"
            type="submit"
            variant="primary"
            class="float-end"
            name="save"
            :disabled="
              v$.userForUpdate.$invalid ||
              savingProfile ||
              !v$.userForUpdate.$anyDirty
            "
            @click.prevent="clickSave"
          >
            {{ $t("buttons.save") }}
          </b-button>
        </CoscineFormGroup>
      </b-form>

      <!-- Merge Accounts Modal -->
      <MergeUserModal :provider-to-merge="providerToMerge" />
      <MergeUserModalV2
        :external-auth-name="externalAuthName"
        :external-auth-id="externalAuthId"
      />
    </div>
    <div class="col-sm-2" />
  </b-row>
</template>

<script lang="ts">
import { required, email, maxLength } from "@vuelidate/validators";
import { useVuelidate } from "@vuelidate/core";
import AccessToken from "./components/AccessToken.vue";
import MergeUserModal from "./modals/MergeUserModal.vue";
import MergeUserModalV2 from "./modals/MergeUserModalV2.vue";

// import the store for current module
import useUserStore from "../store";
import useLoginStore from "@/modules/login/store";
import useNotificationStore from "@/store/notification";
import type {
  DisciplineDto,
  IdentityProviders,
  TitleDto,
  UserDto,
  UserForUpdateDto,
} from "@coscine/api-client/dist/types/Coscine.Api";
import { UserDto2UserForUpdateDto, userMapper } from "@/mapping/user";
import { RadioOptionRaw, useModal } from "bootstrap-vue-next";

export default defineComponent({
  components: { AccessToken, MergeUserModal, MergeUserModalV2 },
  setup() {
    const loginStore = useLoginStore();
    const notificationStore = useNotificationStore();
    const userStore = useUserStore();

    const mergeUserModal = useModal("mergeUserModal");
    const mergeUserModalV2 = useModal("mergeUserModalV2");

    const v$ = useVuelidate();
    return {
      loginStore,
      notificationStore,
      userStore,
      mergeUserModal,
      mergeUserModalV2,
      v$,
    };
  },

  data() {
    return {
      userForUpdate: {
        title: {}, // This needs to be nullified for the multiselect's placeholder
        givenName: "",
        familyName: "",
        email: "",
        organization: "",
        institute: "",
        disciplines: [] as DisciplineDto[],
        language: {},
      } as UserForUpdateDto,
      searchCharThreshold: 3,
      isLoading: false,
      savingProfile: false,
      currentUserComponent: "UserProfileComponent",
      selectedExternalOrganization: null as Record<string, unknown> | null,
      queryTimer: 0,
      isLoadingOrganizations: false,
      providerToMerge: null as IdentityProviders | null,
      externalAuthName: null as string | null,
      externalAuthId: null as string | null,
    };
  },
  computed: {
    disciplineLabel(): string {
      let locale = this.$i18n.locale;
      // Ensure that the value of locale is a valid locale, otherwie the property for disciplineLabel will be inaccurate
      if (this.$i18n.availableLocales.includes(locale) === false) {
        locale = this.$i18n.fallbackLocale.toString();
      }
      locale = locale.charAt(0).toUpperCase() + locale.slice(1);
      return `displayName${locale}`;
    },
    disciplines(): DisciplineDto[] {
      return this.userStore.userProfile.disciplines
        ? this.userStore.userProfile.disciplines
        : [];
    },
    emailHint(): string {
      if (!this.userForUpdate.email) {
        return this.$t(
          "page.userprofile.form.personalInformation.emailChange.noAddress",
        ).toString();
      } else if (!this.user?.emails?.some((e) => e.isConfirmed)) {
        return this.$t(
          "page.userprofile.form.personalInformation.emailChange.pendingConfirmation",
        ).toString();
      }
      return "";
    },
    languages(): readonly RadioOptionRaw[] | undefined {
      return this.userStore.userProfile.languages ?? undefined;
    },
    orcidConnected(): boolean {
      if (this.user?.identities) {
        return this.user.identities.some(
          (idProvider) =>
            idProvider.id &&
            idProvider.id.toLowerCase() ===
              this.loginStore.orcidId.toLowerCase(),
        );
      }
      return false;
    },
    nfdi4IngAaiConnected(): boolean {
      if (this.user?.identities) {
        return this.user.identities.some(
          (idProvider) =>
            idProvider.id &&
            idProvider.id.toLowerCase() ===
              this.loginStore.nfdi4IngAaiId.toLowerCase(),
        );
      }
      return false;
    },
    organizations(): string[] {
      if (this.user?.organizations) {
        return this.user?.organizations
          .map((org) => (org.displayName ? org.displayName : "")) // Extract organization display name, could contain empty strings
          .filter((n) => n); // Filter out empty strings, if any;
      }
      return [];
    },
    readOnlyOrganization(): boolean {
      return this.user?.organizations?.some((o) => o.readOnly) ?? false;
    },
    ror(): string[] {
      const organizations = this.userStore.userProfile.organizations;
      if (organizations) {
        return organizations
          .map((org) => (org.displayName ? org.displayName : "")) // Extract organization display name, could contain empty strings
          .filter((n) => n); // Filter out empty strings, if any
      } else {
        return [];
      }
    },
    shibbolethConnected(): boolean {
      if (this.user?.identities) {
        return this.user?.identities.some(
          (idProvider) =>
            idProvider.displayName &&
            idProvider.displayName.toLowerCase() === "shibboleth",
        );
      }
      return false;
    },
    titles(): TitleDto[] {
      return this.userStore.userProfile.titles
        ? this.userStore.userProfile.titles
        : [];
    },
    user(): UserDto | null | undefined {
      return this.userStore.user;
    },
  },
  validations() {
    const organizationValidator = (value: string) =>
      !!value || this.organizations.length > 0;
    return {
      userForUpdate: {
        title: {},
        givenName: { required, maxLength: maxLength(200) },
        familyName: { required, maxLength: maxLength(200) },
        email: { email, required, maxLength: maxLength(200) },
        organization: { required, organizationValidator },
        disciplines: { required },
        language: { id: { required } },
      },
    };
  },
  watch: {
    user() {
      this.onUserLoaded();
    },
  },
  created() {
    this.onUserLoaded();
  },
  methods: {
    setLanguage(input: string) {
      this.v$.userForUpdate.language.$model = { id: input };
    },
    onUserLoaded() {
      if (this.user) {
        // Fill the form. Note that regular assignment breaks reactivity!
        const mapped = userMapper.map(UserDto2UserForUpdateDto, this.user);
        Object.assign(this.userForUpdate, mapped);
        // Unfortunately need to nullify it, because its not a required prop. Otherwise validation won't react.
        if (!this.user.title) {
          // eslint-disable-next-line  @typescript-eslint/no-non-null-assertion
          this.userForUpdate.title = null!;
        }
      }
    },
    async clickNfdi4IngAaiConnect() {
      this.externalAuthId = this.loginStore.nfdi4IngAaiId;
      this.externalAuthName = this.$t(
        "page.userprofile.form.connectedAccounts.nfdi4ingaai",
      );
      this.providerToMerge = null;
      this.mergeUserModalV2.show();
    },
    async clickOrcidConnect() {
      this.externalAuthId = this.loginStore.orcidId;
      this.externalAuthName = this.$t(
        "page.userprofile.form.connectedAccounts.orcid",
      );
      this.providerToMerge = null;
      this.mergeUserModalV2.show();
    },
    async clickSsoConnect() {
      return;
      // this.externalAuthId = null;
      // this.externalAuthName = null;
      // await this.clickConnect("Shibboleth");
    },
    async clickConnect(provider: IdentityProviders) {
      this.providerToMerge = provider;
      this.mergeUserModal.show();
    },
    async clickSave() {
      this.v$.userForUpdate.$touch();
      if (!this.v$.userForUpdate.$invalid && this.v$.userForUpdate.$anyDirty) {
        this.savingProfile = true;
        const updatedUser = await this.userStore.updateUser(this.userForUpdate);
        if (updatedUser) {
          // On Success
          this.v$.userForUpdate.$reset();
          this.notificationStore.postNotification({
            title: this.$t("toast.onSave.success.title").toString(),
            body: this.$t("toast.onSave.success.message").toString(),
          });
        } else {
          // On Failure
          this.notificationStore.postNotification({
            title: this.$t("toast.onSave.failure.title").toString(),
            body: this.$t("toast.onSave.failure.message").toString(),
            variant: "danger",
          });
        }
        await this.userStore.retrieveUser();
        this.savingProfile = false;
      }
    },
    triggerFetchOptions(search: string) {
      clearTimeout(this.queryTimer);
      if (search.length < this.searchCharThreshold) {
        return;
      }
      this.isLoadingOrganizations = true; // Set the flag here, to avoid delayed loading indication
      this.queryTimer = window.setTimeout(
        () => this.fetchOrganizationOptions(search),
        1000,
      );
    },
    async fetchOrganizationOptions(search: string) {
      await this.userStore.retrieveOrganizations(search);
      this.isLoadingOrganizations = false;
    },
  },
});
</script>
